--dashboard
INSERT INTO public.dashboard_view(
	view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option)
	VALUES (DEFAULT,'DASHBOARD_API_ALARM','/dashboard/view_api_alert.php?id=:widgetid',30, 100, 300,'{"title":{"style":"text-align: center; font-size:15px; color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"table":{"class":"arraytop","style":"width:60%; height:60%; margin: auto; border-spacing: 10px 10px;"},"td":{"style":"font-size:50px;"}}');

CREATE TABLE dashboard_widget_group
(
  widget_group_id serial NOT NULL,
  widget_group_name character varying(30),
  CONSTRAINT widget_group_primary_key PRIMARY KEY (widget_group_id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE dashboard_widget_group
  OWNER TO esia;


ALTER TABLE dashboard_view
   ADD COLUMN view_group_id integer;


ALTER TABLE dashboard_view
  ADD CONSTRAINT view_foreignkey_group_id FOREIGN KEY (view_group_id) REFERENCES dashboard_widget_group (widget_group_id)
   ON UPDATE NO ACTION ON DELETE NO ACTION;


INSERT INTO dashboard_widget_group(widget_group_id, widget_group_name) VALUES (DEFAULT,'STATE');
INSERT INTO dashboard_widget_group(widget_group_id, widget_group_name) VALUES (DEFAULT,'PLAN');
INSERT INTO dashboard_widget_group(widget_group_id, widget_group_name) VALUES (DEFAULT,'APPLICATIVE');
INSERT INTO dashboard_widget_group(widget_group_id, widget_group_name) VALUES (DEFAULT,'SERVICE');
INSERT INTO dashboard_widget_group(widget_group_id, widget_group_name) VALUES (DEFAULT,'TAB');

UPDATE dashboard_view SET view_group_id=(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='STATE')
WHERE view_name LIKE '%STATE%';
UPDATE dashboard_view SET view_group_id=(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='PLAN')
WHERE view_name LIKE '%PLAN%';
UPDATE dashboard_view SET view_group_id=(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='APPLICATIVE')
WHERE view_name LIKE '%APPLICATIVE%';

UPDATE dashboard_view SET view_group_id=(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='SERVICE')
WHERE view_name LIKE '%VALUE%';
UPDATE dashboard_view SET view_group_id=(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='SERVICE')
WHERE view_name LIKE '%GRAPHIC%';


INSERT INTO public.dashboard_view(
	view_id, view_name, view_file_path, view_during, view_default_height, view_default_width, view_default_option)
	VALUES (DEFAULT,'DASHBOARD_NODE_TYPE_TAB','/dashboard/view_tab_devicetype.php?id=:widgetid',30, 100, 300,'{"title":{"style":"text-align: center; font-size:15px;color:#575759;"},"description":{"style":"text-align: center; margin:auto;font-size:12px;"},"table":{"class":"arraytop","style":"width:60%; height:60%; margin: auto; border-spacing: 10px 10px;"},"td":{"style":"font-size:50px;"},"type":"table","warning":1,"critical":1,"unknown":1,"statusonly":0,"order":[]}');
UPDATE dashboard_view SET view_group_id=(SELECT widget_group_id FROM dashboard_widget_group WHERE widget_group_name='TAB')
WHERE view_name LIKE 'DASHBOARD_NODE_TYPE_TAB';

--availability
CREATE OR REPLACE FUNCTION get_availability(
    nodeid bigint,
    serviceid bigint,
    stardate timestamp without time zone,
    enddate timestamp without time zone)
  RETURNS real AS
$BODY$
DECLARE 
	nbrsec bigint;
	v_ava real = 100;
	percent real;
	r RECORD;
BEGIN		
	SELECT date_part('epoch', enddate - stardate) INTO nbrsec;
	--CALCUL du nombre de seconde d'indisponnibilité
	FOR r IN SELECT error_type,SUM (sec_in_error) as time_notavailable 
		FROM (
			--Si l'erreur c'est produite entre l'interval de temps
			SELECT error_type, date_part('epoch',SUM(happen_time_acquitte - happen_timestamp)) as sec_in_error
			FROM ( 
				SELECT error_type, happen_timestamp, happen_time_acquitte
				FROM esia_error_happen
				LEFT JOIN esia_errors ON error_id = happen_error_id
				WHERE happen_service_id = serviceid AND happen_device_id = nodeid AND error_type <> 'unknown'
					AND happen_timestamp > stardate
					AND happen_timestamp < enddate
				) AS T2
			WHERE T2.happen_time_acquitte < enddate
			GROUP BY T2.error_type

			UNION
			--Si l'erreur c'est produite durant l'interval de temps et que le acuitte es§t toujours actif ou après le enddate
			SELECT error_type, date_part('epoch',SUM(happen_time_acquitte - happen_timestamp)) as sec_in_error
			FROM  ( 
				SELECT error_type, happen_timestamp, happen_time_acquitte
				FROM esia_error_happen
				LEFT JOIN esia_errors ON error_id = happen_error_id
				WHERE happen_service_id = serviceid AND happen_device_id = nodeid AND error_type <> 'unknown'
					AND happen_timestamp > stardate
					AND happen_timestamp < enddate
			) AS T2
			WHERE happen_time_acquitte > enddate 
				OR happen_time_acquitte IS NULL 
			GROUP BY error_type
			
			UNION
			--si l'erreur c'est produite avant la start date et est toujours active ou que le time acquite est après la date de fin
			SELECT error_type, date_part('epoch',SUM(enddate - stardate)) as sec_in_error
			FROM esia_error_happen
			LEFT JOIN esia_errors ON error_id = happen_error_id
			WHERE happen_service_id = serviceid AND error_type <> 'unknown'
				AND happen_timestamp < stardate
				AND ( happen_acquitte=0 OR happen_time_acquitte > enddate)
			GROUP BY error_type
				--service non présent
			UNION
				SELECT 'nopresent' as error_type,date_part('epoch',SUM(enddate -stardate )) as sec_in_error
				FROM esia_services
				WHERE service_id = serviceid
					AND service_time_added >  stardate
			) A GROUP BY error_type
	LOOP
		--RAISE NOTICE 'i want to print % and % %', r.time_notavailable ,r.error_type,nbrsec ;
		IF r.time_notavailable > 0
		THEN
			percent = (r.time_notavailable / nbrsec)*100;
		ELSE
			percent=0;
		END IF;
		--RAISE NOTICE 'percent: %',percent;
		v_ava = v_ava - percent;
		IF v_ava < 0
		THEN
			v_ava=0;
		END IF;
	END LOOP;
	return v_ava;
	


END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION get_availability(bigint, bigint, timestamp without time zone, timestamp without time zone)
  OWNER TO esia;

--Issue #617
CREATE OR REPLACE FUNCTION get_timeerror(
    IN nodeid bigint,
    IN serviceid bigint,
    IN stardate timestamp without time zone,
    IN enddate timestamp without time zone)
  RETURNS TABLE(type character varying, nbrsec double precision) AS $BODY$
BEGIN	
	SELECT date_part('epoch', enddate - stardate) INTO nbrsec;
	RETURN QUERY SELECT error_type, date_part('epoch',SUM(date_trunc('second',happen_time_acquitte) - date_trunc('second',happen_timestamp))) as sec_in_error FROM (
                --L'erreur de fin coupée
		SELECT error_type,happen_timestamp,enddate AS happen_time_acquitte
		FROM esia_error_happen 
		LEFT JOIN esia_errors ON error_id = happen_error_id
		WHERE happen_service_id = serviceid AND happen_device_id = nodeid
		AND happen_timestamp < enddate
		AND happen_time_acquitte > enddate
		UNION
                --Les erreurs qui ne sont pas coupées
		SELECT error_type,happen_timestamp,happen_time_acquitte 
		FROM esia_error_happen
		LEFT JOIN esia_errors ON error_id = happen_error_id
		WHERE happen_service_id = serviceid AND happen_device_id = nodeid
		AND happen_timestamp > stardate
		AND happen_time_acquitte < enddate
		UNION
                --L'erreur de début coupée
		SELECT error_type,stardate AS happen_timestamp,happen_time_acquitte 
		FROM esia_error_happen
		LEFT JOIN esia_errors ON error_id = happen_error_id
		WHERE happen_service_id = serviceid AND happen_device_id = nodeid
		AND happen_timestamp < stardate
		AND happen_time_acquitte > stardate
	) AS T2
	GROUP BY T2.error_type
	UNION
	SELECT 'total', date_part('epoch', enddate - stardate);
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION get_timeerror(bigint, bigint, timestamp without time zone, timestamp without time zone)
  OWNER TO esia;

CREATE OR REPLACE FUNCTION getnodesstate(userid integer)
 RETURNS TABLE(typerror character varying, nbr bigint)
 LANGUAGE plpgsql
AS $function$
DECLARE 

BEGIN 
CREATE TEMP TABLE userNode ON COMMIT DROP AS SELECT * FROM view_node_state WHERE device_id IN ( SELECT * FROM getUserAccessNode(userid));


RETURN QUERY  SELECT 'ok'::varchar,count(*)::integer
FROM userNode
WHERE warning=0 AND critical=0 AND unknown=0 AND ok > 0
UNION
SELECT 'critical',count(*) FROM userNode
WHERE critical>0
UNION
SELECT 'warning',count(*) FROM userNode
WHERE critical=0 AND warning>0
UNION
SELECT 'unknown',count(*) FROM userNode
WHERE critical=0 AND warning=0 AND unknown>0;

DROP TABLE userNode;

END;
$function$;

ALTER FUNCTION getnodesstate(userid integer)
  OWNER TO esia;

